package move;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class Body extends Applet implements Runnable, MouseMotionListener, MouseListener, KeyListener {
	MemoryImageSource mis;
	Thread thr;
	Image img;
	int[] dat;
	boolean fin, button, inside;
	int key, wid, hig, wi1, hi1, mx, my;

	public void set(int id) { dat[id] = 0; }

	public void draw() {
    	for(int i = 0; i < (wid * hig); i++)
    		if(dat[i] != 0x00ffffff) dat[i] = 0x00ffffff;

		BodyPart bp;

		bp = new BodyPart(getImage(getCodeBase(),"fuss_l.gif"), this);
		bp.paint(dat, wid, wid/2-33, 560, 0, 300);
		bp = new BodyPart(getImage(getCodeBase(),"fuss_r.gif"), this);
		bp.paint(dat, wid, wid/2+22, 560, 0, 300);
		bp = new BodyPart(getImage(getCodeBase(),"bein_l.gif"), this);
		bp.paint(dat, wid, wid/2-38, 390, 0, 300);
		bp = new BodyPart(getImage(getCodeBase(),"bein_r.gif"), this);
		bp.paint(dat, wid, wid/2+32, 390, 0, 300);
		bp = new BodyPart(getImage(getCodeBase(),"becken.gif"), this);
		bp.paint(dat, wid, wid/2-8, 275, 0, 180);
		bp = new BodyPart(getImage(getCodeBase(),"brust.gif"), this);
		bp.paint(dat, wid, wid/2-10, 167, 0, 250);
		bp = new BodyPart(getImage(getCodeBase(),"kopf.gif"), this);
		bp.paint(dat, wid, wid/2, 60, 0, 150);
		bp = new BodyPart(getImage(getCodeBase(),"arm_l.gif"), this);
		bp.paint(dat, wid, wid/2-70, 180, 0, 200);
		bp = new BodyPart(getImage(getCodeBase(),"arm_r.gif"), this);
		bp.paint(dat, wid, wid/2+60, 180, 0, 200);
		bp = new BodyPart(getImage(getCodeBase(),"elle_l.gif"), this);
		bp.paint(dat, wid, wid/2-80, 285, 0, 180);
		bp = new BodyPart(getImage(getCodeBase(),"elle_r.gif"), this);
		bp.paint(dat, wid, wid/2+60, 285, 0, 180);
		bp = new BodyPart(getImage(getCodeBase(),"hand_l.gif"), this);
		bp.paint(dat, wid, wid/2-70, 360, 0, 150);
		bp = new BodyPart(getImage(getCodeBase(),"hand_r.gif"), this);
		bp.paint(dat, wid, wid/2+60, 360, 0, 150);

		mis.newPixels();
	}

	public void init() {
		wid = getBounds().width;  wi1 = wid - 1;
		hig = getBounds().height; hi1 = hig - 1;
		img = createImage(wid,hig);
		thr = new Thread(this);
		dat = new int[wid*hig];
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
		setBackground(Color.white);

		DirectColorModel dcm = new DirectColorModel(32,0x00ff0000,0x0000ff00,0x000000ff,0);
    	mis = new MemoryImageSource(wid, hig, dcm, dat, 0, wid);
    	mis.setAnimated(true);
    	mis.setFullBufferUpdates(true);
    	img = createImage(mis);

    	for(int i = 0; i < (wid * hig); i++)
    		if(dat[i] != 0x00ffffff) dat[i] = 0x00ffffff;
    }

	public void start() { fin=false; thr.start(); }
	public void destroy() { fin=true; }
	public void run() { while(!fin) { draw(); repaint(); pause(40); } thr=null; }
	public void update(Graphics g) { g.drawImage(img,0,0,this); }
	public void pause(int time) { try { thr.sleep(time); } catch(Exception e) {} }

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) { key = e.getKeyCode(); }
	public void keyReleased(KeyEvent e) {}

	public void mouseMoved   (MouseEvent e) { mx=e.getX(); my=e.getY(); }
	public void mouseClicked (MouseEvent e) { mx=e.getX(); my=e.getY(); }
	public void mousePressed (MouseEvent e) { mx=e.getX(); my=e.getY(); button=true;  }
	public void mouseReleased(MouseEvent e) { mx=e.getX(); my=e.getY(); button=false; }
	public void mouseEntered (MouseEvent e) { mx=e.getX(); my=e.getY(); inside=true;  }
	public void mouseExited  (MouseEvent e) { mx=e.getX(); my=e.getY(); inside=false; }
	public void mouseDragged (MouseEvent e) { mx=e.getX(); my=e.getY(); }

public void drawLine(int x1, int y1, int x2, int y2) {
    if(x1 == x2)
        if(y1 == y2) { set(y1 * wid + x1); return; }  // point
        else {                                          // vertical line
            int i1 = y1 * wid + x1;
            int i2 = y2 * wid + x2;
            if(y1 < y2) while(i1 != i2) { set(i1); i1+= wid; }
            else        while(i1 != i2) { set(i1); i1-= wid; }
            set(i2); return;
        }
    else if(y1 == y2) {                                 // horizontal line
        int id = y1 * wid;
        int i1 = id + x1;
        int i2 = id + x2;
        if(x1 < x2) while(i1 != i2) set(i1++);
        else        while(i1 != i2) set(i1--);
        set(i2); return;
    }                                                   // other lines:
    int hp, f1, f2;                                     // bresenham algorithm
    int dx = x2 - x1;
    int dy = y2 - y1;
    int i1 = y1 * wid + x1;
    int i2 = y2 * wid + x2;
    if(Math.abs(dx) > Math.abs(dy)) {                   // alpha < 45 degrees
        if(dx > 0) {
            if(dy > 0) {
                f1 = dy *  2; hp = f1 - dx; f2 = hp - dx;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1+= wid; }
                    i1++; }
            } else {
                f1 = dy * -2; hp = f1 - dx; f2 = hp - dx;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1-= wid; }
                    i1++; }
            }
        } else {
            if(dy > 0) {
                f1 = dy *  2; hp = f1 + dx; f2 = hp + dx;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1+= wid; }
                    i1--; }
            } else {
                f1 = dy * -2; hp = f1 + dx; f2 = hp + dx;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1-= wid; }
                    i1--; }
            }
        }
    } else {                                            // alpha > 45 degrees
        if(dx > 0) {
            if(dy > 0) {
                f1 = dx *  2; hp = f1 - dy; f2 = hp - dy;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1++; }
                    i1+= wid; }
            } else {
                f1 = dx *  2; hp = f1 + dy; f2 = hp + dy;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1++; }
                    i1-= wid; }
            }
        } else {
            if(dy > 0) {
                f1 = dx * -2; hp = f1 - dy; f2 = hp - dy;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1--; }
                    i1+= wid; }
            } else {
                f1 = dx * -2; hp = f1 + dy; f2 = hp + dy;
                while(i1 != i2) {
                    set(i1);
                    if(hp < 0) hp+= f1; else { hp+= f2; i1--; }
                    i1-= wid; }
            }
        }
    }
    set(i2);
}
}