package move;

import java.awt.*;
import java.awt.image.*;

public class BodyPart {
	int[] prt;
	int wid=-1, hig=-1, wi2, hi2;

	public void paint(int[] dat, int w, int x, int y, int dx, int dy) {
		int i,a,r,g,b,fr,fg,fb,c,v,id = 0;
		int gx,gy,nx,ny,ly;

		double l = Math.sqrt(dx * dx + dy * dy) * 256;
		int s = (int)Math.round(l / (double)hig);
		double q = Math.atan2(dx, dy);
		int sin = (int)Math.round(Math.sin(q) * 256);
		int cos = (int)Math.round(Math.cos(q) * 256);

		for(int py = -hi2; py < hig-hi2; py++)
		for(int px = -wi2; px < wid-wi2; px++) {
			c = prt[id++];
			if((c & 0xff000000) != 0) {
				a = c >>> 24;
				r = c & 0x00ff0000;
				g = c & 0x0000ff00;
				b = c & 0x000000ff;
				gx = px << 8;
				gy = py * s;
				nx = (gx * cos - gy * sin) >> 8;
				ny = (gx * sin + gy * cos) >> 8;
				ly = ny + s;

				int sx = (int)((nx >> 8) + x);
				int sy = (int)((ny >> 8) + y);
				int ey = (int)((ly >> 8) + y);

				i = sy * w + sx;
				for(int yy = sy; yy <= ey; yy++) {
					c = dat[i];
					v = 255 - a;
					fr = ((c & 0x00ff0000) * v + r * a) & 0xff000000;
					fg = ((c & 0x0000ff00) * v + g * a) & 0x00ff0000;
					fb = ((c & 0x000000ff) * v + b * a) & 0x0000ff00;
					dat[i] = (fr|fg|fb)>>>8;
					i+= w;
				}
			}
		}
	}

	public BodyPart(Image img, ImageObserver iob) {
		while(wid < 0 || hig < 0) {
			wid = img.getWidth(iob);  wi2 = wid / 2;
			hig = img.getHeight(iob); hi2 = hig / 2;
			Toolbox.sleep(100);
		}
		prt = new int[wid*hig];
		PixelGrabber pg = new PixelGrabber(img, 0, 0, wid, hig, prt, 0, wid);
		try { pg.grabPixels(); } catch(Exception e) { System.err.println(e); }
		if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
		    System.err.println("BodyPart: image fetch aborted or errored.");
		}
	}
}