package move;

import java.awt.*;

// class for using full screen as display
public class FullScreen extends Frame {
	protected int X,Y,BPP;
	private GraphicsDevice device;

	// Frame using full screen having dimension w*h, bits per pixel and (in)visible mouse
	public FullScreen(int w, int h, int bits, boolean hideMouse) throws Exception {
		super(GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration());
		device = getGraphicsConfiguration().getDevice();
		setFullScreen(device);
		X=w; Y=h; BPP=bits;
		setDisplayMode(device);
		if(hideMouse) hideMouse();
	}
	// (sets dimension of display)
    private void setDisplayMode(GraphicsDevice device) {
        DisplayMode[] m = device.getDisplayModes();
        for (int i = 0; i < m.length; i++)
            if (m[i].getWidth()==X && m[i].getHeight()==Y && m[i].getBitDepth()==BPP)
            	device.setDisplayMode(m[i]);
    }
	// (changes to full-screen-view)
	private void setFullScreen(GraphicsDevice device) throws Exception {
		setUndecorated(true);
		setIgnoreRepaint(true);
		device.setFullScreenWindow(this);
		if(!device.isDisplayChangeSupported()) throw new Exception("DisplayMode not supported.");
	}
	// hiding mouse
	public void hideMouse() throws Exception {
		Toolkit tk = getToolkit();
		Image crsi= tk.getImage("transparentCursor");
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(crsi, 0);
		mt.waitForID(0);
		setCursor(tk.createCustomCursor(crsi, new Point(0,0), "transparentCursor"));
	}
	// have to be called to exit full screen
	public void dispose() { device.setFullScreenWindow(null); super.dispose(); }
}