package move;

import java.io.*;
import java.util.*;

// class handling storing and loading marker-infos to and from disk
public class MarkerFile {
	private Hashtable hash = new Hashtable();		// the hashtable with all markers
	private String file;							// the file to read from and write to

	// creates a marker handling object using file
	public MarkerFile(String file) { this.file=file; }

	// clears current markers and loads from file
	public void load() {
		if(!Toolbox.exists(file)) return;
		try {
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
			hash.clear();
			try { while(true) put((Marker)(in.readObject()));
			} catch(EOFException e) {}
			in.close();
		} catch(Exception x) { x.printStackTrace(); }
	}
	// stores current markers to file
	public void store() {
		try {
			ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(file));
			for (Enumeration e = hash.elements() ; e.hasMoreElements();)
				out.writeObject((Marker)e.nextElement());
			out.close();
		} catch(Exception x) { x.printStackTrace(); }
	}
	// amount of markers
	public int size() { return hash.size(); }
	// exists marker with name?
	public boolean exists(String name) { return hash.containsKey(name); }
	// adds marker to hashtable
	public void put(Marker m) { hash.put(m.name,m); }
	// removes marker from hashtable
	public void del(String name) { hash.remove(name); }
	// returns marker with name or null
	public Marker get(String name) { if(exists(name)) return (Marker)(hash.get(name)); return null; }
	// returns Enumeration of Hashtable
	public Enumeration elements() { return hash.elements(); }
}
