package move;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

public class UserInterface extends FullScreen implements KeyListener,MouseListener,MouseMotionListener {
	MemoryImageSource mis;
	Image img;
	int[] dat,bgd;
	boolean fin, button=false, inside;
	int key, wid, hig, wi1, hi1, mx, my;

	private Graphics g;												// Graphics of Frame
	private MarkerFile mrk=null;									// current MarkerFile
	private int index=0;											// index of file
	private String path;											// path to files

	BodyPart kopf,brust,becken,bein_l,bein_r,fuss_l,fuss_r,arm_l,arm_r,elle_l,elle_r,hand_l,hand_r;

	public void draw() {
    	for(int i = 0; i < (wid * hig); i++)
    		if(dat[i] != bgd[i]) dat[i] = bgd[i];

		if(!Toolbox.exists(file(index,"mrk"))) index = 0;
		mrk = new MarkerFile(file(index,"mrk"));
		mrk.load();

		Marker m1,m2;
		int x,y,dx,dy;

		m1 = mrk.get("s");			m2 = mrk.get("kl");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		bein_l.paint(dat,wid,x-5,y+25,dx-5,dy);

		m1 = mrk.get("s");			m2 = mrk.get("kr");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		bein_r.paint(dat,wid,x+25,y+25,dx-5,dy);

		m1 = mrk.get("kl");			m2 = mrk.get("zl");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		fuss_l.paint(dat,wid,x-5,y+50,dx,dy+5);

		m1 = mrk.get("kr");			m2 = mrk.get("zr");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		fuss_r.paint(dat,wid,x+20,y+50,dx,dy+5);

		m1 = mrk.get("b");			m2 = mrk.get("s");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		becken.paint(dat,wid,x+7,y+20,dx,dy+10);

		m1 = mrk.get("h");			m2 = mrk.get("b");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		brust.paint(dat,wid,x,y+10,dx,dy);

		m1 = mrk.get("al");			m2 = mrk.get("ar");
		x  = (m1.x + m2.x) / 2;		y  = (m1.y + m2.y) / 2;
		m1 = mrk.get("h");
		dx = (x - m1.x);			dy = (m1.y - y);
		x  = x * 2 / 3;					y  = y * 2 / 3;
		kopf.paint(dat,wid,x+2,y,dx,dy+70);

		m1 = mrk.get("sl");			m2 = mrk.get("el");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		arm_l.paint(dat,wid,x-20,y+30,dx,dy+10);

		m1 = mrk.get("sr");			m2 = mrk.get("er");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		arm_r.paint(dat,wid,x+25,y+30,dx,dy+10);

		m1 = mrk.get("el");			m2 = mrk.get("hl");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		elle_l.paint(dat,wid,x-20,y+35,dx,dy+5);

		m1 = mrk.get("er");			m2 = mrk.get("hr");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		elle_r.paint(dat,wid,x+30,y+35,dx,dy+5);

		m1 = mrk.get("hl");			m2 = mrk.get("ml");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		hand_l.paint(dat,wid,x-13,y+45,dx,dy);

		m1 = mrk.get("hr");			m2 = mrk.get("mr");
		dx = (m1.x - m2.x);			dy = (m2.y - m1.y);
		x  = (m1.x + m2.x) / 3;		y  = (m1.y + m2.y) / 3;
		hand_r.paint(dat,wid,x+33,y+42,dx,dy);

		FotoWriter.write(img,this,wid,hig,Toolbox.getString(index,4));
		mis.newPixels();
		while(mx < 10) Toolbox.sleep(10);
	}

	public UserInterface(String path, String name, int bpp) throws Exception {
		super(1024,768,bpp,false);
		this.path=path+Toolbox.FileSep+name;
		g = getGraphics();
		wid = 1024; wi1 = wid - 1;
		hig = 768;  hi1 = hig - 1;
		img = createImage(wid,hig);
		dat = new int[wid*hig];
		addKeyListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);

		DirectColorModel dcm = new DirectColorModel(32,0x00ff0000,0x0000ff00,0x000000ff,0);
    	mis = new MemoryImageSource(wid, hig, dcm, dat, 0, wid);
    	mis.setAnimated(true);
    	mis.setFullBufferUpdates(true);
    	img = createImage(mis);

    	Toolkit tk = getToolkit();
		fuss_l = new BodyPart(tk.createImage("fuss_l.gif"), this);
		fuss_r = new BodyPart(tk.createImage("fuss_r.gif"), this);
		bein_l = new BodyPart(tk.createImage("bein_l.gif"), this);
		bein_r = new BodyPart(tk.createImage("bein_r.gif"), this);
		becken = new BodyPart(tk.createImage("becken.gif"), this);
		brust  = new BodyPart(tk.createImage("brust.gif"), this);
		kopf   = new BodyPart(tk.createImage("kopf.gif"), this);
		arm_l  = new BodyPart(tk.createImage("arm_l.gif"), this);
		arm_r  = new BodyPart(tk.createImage("arm_r.gif"), this);
		elle_l = new BodyPart(tk.createImage("elle_l.gif"), this);
		elle_r = new BodyPart(tk.createImage("elle_r.gif"), this);
		hand_l = new BodyPart(tk.createImage("hand_l.gif"), this);
		hand_r = new BodyPart(tk.createImage("hand_r.gif"), this);

		Image bg = tk.createImage("bg.jpg");
		while(bg.getWidth(this) < 0 || bg.getHeight(this) < 0) Toolbox.sleep(100);
		bgd = new int[wid*hig];
		PixelGrabber pg = new PixelGrabber(bg, 0, 0, wid, hig, bgd, 0, wid);
		try { pg.grabPixels(); } catch(Exception e) { System.err.println(e); }
		if ((pg.getStatus() & ImageObserver.ABORT) != 0) {
		    System.err.println("BodyPart: image fetch aborted or errored.");
		}
	}
	public void start() {
		while(!button) {
			draw();
			g.drawImage(img,0,0,this);
			index++;
			Toolbox.sleep(100);
		}
	}
	// creates filename with path for index with suffix
	private String file(int index, String suffix) { return path+Toolbox.getString(index,4)+"."+suffix; }

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) { key = e.getKeyCode(); }
	public void keyReleased(KeyEvent e) {}

	public void mouseMoved   (MouseEvent e) { mx=e.getX(); my=e.getY(); }
	public void mouseClicked (MouseEvent e) { mx=e.getX(); my=e.getY(); }
	public void mousePressed (MouseEvent e) { mx=e.getX(); my=e.getY(); button=true;  }
	public void mouseReleased(MouseEvent e) { mx=e.getX(); my=e.getY(); button=false; }
	public void mouseEntered (MouseEvent e) { mx=e.getX(); my=e.getY(); inside=true;  }
	public void mouseExited  (MouseEvent e) { mx=e.getX(); my=e.getY(); inside=false; }
	public void mouseDragged (MouseEvent e) { mx=e.getX(); my=e.getY(); }
}